#pragma once

#include <string>

#include "cinematic.h"

class AnimationSystem {
public:
    Cinematic* loadCinematic(const std::string& path);
    
    void update(Cinematic* cinematic, float deltaTime);
    
private:
    void preloadShot(Shot* shot);
    void loadShot(Shot* shot);
    void unloadShot(Shot* shot);
    
    float animationTime = 0.0f;
    int currentShot = 0;
};
