#pragma once

#include <vulkan/vulkan.h>
#include <glm/glm.hpp>

class Renderer;
struct RenderTarget;
struct RenderCollection;
struct RenderExtraInfo;

class DebugPass {
public:
    DebugPass(Renderer& renderer);
    ~DebugPass();

    void render(VkCommandBuffer commandBuffer, RenderCollection& collection, RenderExtraInfo* extraInfo, RenderTarget* target);

    VkRenderPass getRenderPass() const {
        return renderPass_;
    }

private:
    void createRenderPass();
    void createPipeline();

    VkRenderPass renderPass_ = nullptr;

    VkPipeline pipeline_ = nullptr;
    VkPipelineLayout pipelineLayout_ = nullptr;

    Renderer& renderer_;
};
