#pragma once

#include <vector>
#include <string>
#include <cstdint>
#include <glm/glm.hpp>
#include <vulkan/vulkan.h>

struct Vertex {
    glm::vec3 position, normal;
    glm::vec2 uv;
};

struct MeshAsset {
    std::vector<Vertex> vertices;
    std::vector<uint32_t> indices;

    VkBuffer vertexBuffer = nullptr;
    VkDeviceMemory vertexMemory = nullptr;

    VkBuffer indexBuffer = nullptr;
    VkDeviceMemory indexMemory = nullptr;
};
