#pragma once

#include <vector>

struct TransformComponent;
struct MeshComponent;
struct LightComponent;
struct CameraComponent;

using EntityID = uint64_t;

struct RenderLight {
    TransformComponent* transform = nullptr;
    LightComponent* light = nullptr;
};

struct RenderMesh {
    EntityID entity;

    TransformComponent* transform = nullptr;
    MeshComponent* mesh = nullptr;
};

struct RenderCamera {
    TransformComponent* transform = nullptr;
    CameraComponent* camera = nullptr;
};

struct RenderCollection {
    std::vector<RenderLight> lights;
    std::vector<RenderMesh> meshes;

    RenderCamera camera;
};
