#version 460 core
#extension GL_GOOGLE_include_directive : enable

#define SMAA_RT_METRICS vec4(1.0 / 1280.0, 1.0 / 720.0, 1280.0, 720.0)

#define SMAA_PRESET_ULTRA 1
#define SMAA_GLSL_4 1
#define SMAA_INCLUDE_VS 0
#define SMAA_INCLUDE_PS 1
#define SMAA_PREDICATION 1
#define SMAA_FLIP_Y 0

#include "smaa.glsl"

layout(location = 0) in vec2 inUV;
layout(location = 1) in vec4 inOffset[3];

layout(location = 0) out vec4 outColor;

layout(binding = 0) uniform sampler2D imageSampler;
layout(binding = 1) uniform sampler2D depthSampler;

void main() {
    vec2 edge = SMAALumaEdgeDetectionPS(inUV, inOffset, imageSampler, depthSampler);

    outColor = vec4(edge, 0.0, 1.0);
}
