#pragma once

#include <QWindow>
#include <vulkan/vulkan.h>

#include "context.h"

struct RenderTarget;

class RendererWindow : public QWindow {
    Q_OBJECT
public:
    RendererWindow(Context& context);

protected:
    void exposeEvent(QExposeEvent* event) override;
    bool event(QEvent* event) override;

private:
    void init();
    void render();

    VkSurfaceKHR surface = nullptr;
    RenderTarget* target = nullptr;

    bool initialized = false;
    Context& context;
};
