#include <QApplication>
#include <QVulkanInstance>

#include "platform.h"

static std::vector<std::string> extensionList;

std::vector<const char*> platform::getRequiredExtensions() {
    QVulkanInstance instance;
    instance.create();

    for(const auto& extension : instance.extensions())
        extensionList.push_back(extension.data());

    instance.destroy();

    std::vector<const char*> extensions;
    for(const auto& extension : extensionList)
        extensions.push_back(extension.c_str());

    return extensions;
}

uint32_t platform::getTime() {
    return 0;
}
