#pragma once

#include <QMainWindow>
#include <QVulkanInstance>
#include <QGridLayout>
#include <QStringList>

struct Context;
struct MeshComponent;

class MainWindow : public QMainWindow {
public:
    MainWindow(Context& context);
    ~MainWindow();

private:
    void openMaterial(QString path);
    void saveMaterial(QString path);

    void updateControls();

    QStringList openedFiles;

    QAction* saveAction, *saveAsAction, *openRecentAction;

    QString currentlyOpenMaterial;
    MeshComponent* meshComponent;

    QGridLayout* attributesLayout;

    Context& context;
    QVulkanInstance* instance = nullptr;
};

