#include <QApplication>
#include <QVulkanInstance>

#include "mainwindow.h"
#include "platform.h"
#include "context.h"
#include "renderer.h"
#include "worldmanager.h"
#include "assetmanager.h"
#include "ecs.h"
#include "editorstyle.h"

int main(int argc, char* argv[]) {
    QApplication app(argc, argv);
    //app.setStyle(new EditorStyle());

    GraphicsConfig config;
    config.shadowResolution = 256;
    config.dofDownscale = 2;
    config.filterPCF = true;
    config.enableImgui = false;

    Context context;
    context.renderer = new Renderer(config);

    assetManager.setRenderer(context.renderer);

    worldManager.loadWorld("matpreview.world");
    worldManager.switchWorld("matpreview.world");

    MainWindow window(context);
    window.show();

    return app.exec();
}
